/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : gene.h                                                   */
/*                                                                       */
/*       Date : November  6, 1997                                        */
/* Updated at : November  6, 1997                                        */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#ifndef _GENE_
#define _GENE_

#include "global.h"

struct struct_Gene
{
   char  *name;  /* name of gene */
   coord_t  x; 
   coord_t  y;   /* gene's coordinates */
   int  index;   /* gene's index */
};

typedef struct struct_Gene type_Gene;

type_Gene* defineGene(char *_name, coord_t _x, coord_t _y,
                        unsigned int _index);


/*
// Calculates Eucledian distance between this gene and _gene and 
// returns the value.
*/
distance_t calculateDistanceTo(type_Gene* from, type_Gene *to);

/* Returns Eucledian distance between this gene and _gene.  */
distance_t distanceTo(type_Gene* from, type_Gene *to);

int getIndex(type_Gene this);

char *getName(type_Gene this); 

int isEqual(type_Gene a, type_Gene b);

int printGene(type_Gene a);

void disposeGene(type_Gene* this);

#endif

